/************************************************************************************
 *
 * PagerPROAECalls.h : PagerPRO AppleEvent calls
 *
 * By : Haider A. Isa
 *
 *  Caravelle Networks Corp.
 * 
 * April 15th, 1992
 * 
 ************************************************************************************/

#define		PAGERPROCREATOR			(ResType) 'CNC5'

#define		errAEEventFailed		-10000

/* AppleEvents Core Suite */
#define		kAECountElements		'cnte'
#define		kAEDoObjectsExist		'doex'
#define		kAEGetData				'getd'
#define		kAESetData				'setd'

/* Core Suite types */
#define		typeObjectSpecifier		'obj '
#define		keyAEObjectClass		'kocl'
#define		keyAERequestType		'rtyp'
#define		keyAEName				'knam'
#define		keyAEData				'data'
#define		keyAEResult				'----'

/* Address Book element types */
#define		ADDRESSBOOK				'ADBK'
#define		USERS					'USER'
#define		GROUPS					'GROP'

/* Send Queue element types */
#define		SENDQUEUESTATUS			'SQUE'
#define		SENTSTATUS				'SENT'
#define		WAITINGSTATUS			'WAIT'
#define		RETRYSTATUS				'RTRY'
#define		FAILEDSTATUS			'FAIL'

#define		ALLITEMS				'ALL '

/* message priority */
#define		NORMALPRIORITY			'NORM'
#define		URGENTPRIORITY			'UGNT'

#define		GROUPSIZE				20

/* group data */
typedef	struct	groupData {
	short			numberOfUsers;				/* users in a group */
	short			addressIndex [GROUPSIZE];	/* group members */
} groupData;

/* address book data record */
typedef	struct addressBookData {
	Str31			nName;						/* entry name */
	short			nType;						/* entry type, User or Group */
	short			messageSize;				/* max size of message */
	groupData		gData;						/* group data */
} addressBookData, *addressBookDataPtr;

typedef	struct sendQueueData {
	Str31		name;							/* send to name */
	short		priority;						/* message priority */
	long		sendTime;						/* time of send */
	short		status;							/* status */
	short		retries;						/* retries */
} sendQueueData, *sendQueueDataPtr;

extern	OSErr	initPagerPROAEInterface ( short portRefNum, long * userRefNum, AEAddressDesc *targetAddress, LocationNameRec *theLocation, PortInfoRec *thePortInfo);
extern	OSErr	countAddressBookItems ( OSType itemType, long * lSize, AEAddressDesc * targetAddress, StringPtr errString);
extern	OSErr	countSendQueueItems ( OSType itemType, long * lSize, AEAddressDesc * targetAddress, StringPtr errString);
extern	OSErr	doAddressExist ( StringPtr addString, long * retValue, AEAddressDesc * targetAddress, StringPtr errString);
extern	OSErr	getAddressBookItem ( long index, Ptr dataRecord, AEAddressDesc * targetAddress, StringPtr errString);
extern	OSErr	getSendQueueItem ( long index, Ptr dataRecord, AEAddressDesc * targetAddress, StringPtr errString);
extern	OSErr	sendMessage ( OSType msgPriority, StringPtr addString, StringPtr msgString, AEAddressDesc * targetAddress, StringPtr errString);

extern	OSErr	countListItems ( OSType listType, OSType itemType, long * lSize, AEAddressDesc * targetAddress, StringPtr errString);
extern	OSErr	getListItem ( OSType listType, long index, Ptr dataRecord, short dataSize, AEAddressDesc * targetAddress, StringPtr errString);
extern	pascal	Boolean	ppsPPCFilter ( LocationNamePtr theLoc, PortInfoPtr thePortInfo);
